#include "attacks.h"
#include <QtXml/qdom.h>
#include <QFile>
#include <QDebug>

CAttacks   attacks;

//--------------------------------------------------------------------------------------------------------
CAttacks::CAttacks()
{

}

//--------------------------------------------------------------------------------------------------------
void CAttacks::readCombosDB()
{
    QDomDocument doc;

    QFile f("databases/combos.xml");
    f.open(QIODevice::ReadOnly);
    doc.setContent(&f);
    f.close();

    QDomElement root = doc.documentElement();
    QDomNode    comboNode = root.firstChild();

    while(!comboNode.isNull())
    {
        if (comboNode.isElement())
        {
            QDomElement combo = comboNode.toElement();

            if (combo.tagName() == "combo")
            {
                SCombo  newCombo;
                int     attackNum = 0;
                QDomElement comboInfo = combo.firstChild().toElement();

                while(!comboInfo.isNull())
                {
                    if (comboInfo.tagName() == "attack")
                    {
                        newCombo.attacks[attackNum].type = comboInfo.attribute("type").toInt();
                        attackNum++;
                    }
                    comboInfo = comboInfo.nextSibling().toElement();
                }
                mCombos.push_back(newCombo);
            }
        }
        comboNode = comboNode.nextSibling();
    }
}

//--------------------------------------------------------------------------------------------------------
void CAttacks::readAttacksDB()
{
    QDomDocument doc;

    QFile f("databases/attacks.xml");
    f.open(QIODevice::ReadOnly);
    doc.setContent(&f);
    f.close();

    QDomElement root = doc.documentElement();
    QDomNode    attackNode = root.firstChild();

    while(!attackNode.isNull())
    {
        if (attackNode.isElement())
        {
            QDomElement attack = attackNode.toElement();

            if (attack.tagName() == "attack")
            {
                SAttack newAttack;
                QDomElement attackInfo = attack.firstChild().toElement();

                while(!attackInfo.isNull())
                {
                    if (attackInfo.tagName() == "type")
                        newAttack.type = attackInfo.text();
                    else if (attackInfo.tagName() == "cooldown")
                        newAttack.cooldown = attackInfo.text().toInt();
                    else if (attackInfo.tagName() == "hitprob")
                        newAttack.hitProbability = attackInfo.text().toInt();
                    else if (attackInfo.tagName() == "damages")
                        newAttack.damages = attackInfo.text().toInt();

                    attackInfo = attackInfo.nextSibling().toElement();
                }

                mAttacks.push_back(newAttack);
            }
        }
        attackNode = attackNode.nextSibling();
    }
}

//--------------------------------------------------------------------------------------------------------
CAttacks::SCombo& CAttacks::getCombo(int num)
{
    return mCombos[num];
}

//--------------------------------------------------------------------------------------------------------
CAttacks::SAttack& CAttacks::getAttack(int num)
{
    return mAttacks[num];
}
